Index: trunk/src/lib/network/Makefile.am
===================================================================
--- trunk/src/lib/network/Makefile.am	(revision 9391)
+++ trunk/src/lib/network/Makefile.am	(revision 9406)
@@ -8,5 +8,4 @@
 		      shared_network_data.cc \
 		      network_socket.cc \
-		      connection_monitor.cc \
 		      network_stream.cc \
                       data_stream.cc \
@@ -20,4 +19,5 @@
 		      network_game_manager.cc \
 		      converter.cc \
+		      peer_info.cc \
 		      message_manager.cc \
 		      network_log.cc \
@@ -25,4 +25,10 @@
 		      player_stats.cc \
 		      udp_broadcast.cc \
+		      \
+		      proxy/network_settings.cc \
+		      \
+				  monitor/connection_monitor.cc \
+		      monitor/network_monitor.cc \
+		      monitor/network_node.cc \
 		      \
 		      synchronizeable_var/synchronizeable_var.cc \
@@ -33,40 +39,55 @@
 		      synchronizeable_var/synchronizeable_float.cc \
 		      synchronizeable_var/synchronizeable_bool.cc \
-		      synchronizeable_var/synchronizeable_uint.cc 
+		      synchronizeable_var/synchronizeable_uint.cc \
+		      synchronizeable_var/synchronizeable_ip.cc \
+		      \
+		      ip.cc
 
 
 
 
-noinst_HEADERS = synchronizeable.h \
-                 network_manager.h \
-                 shared_network_data.h \
-                 network_socket.h \
-                 connection_monitor.h \
-		 network_stream.h \
-                 data_stream.h \
-                 network_protocol.h \
-		 server_socket.h \
-		 tcp_server_socket.h \
-		 tcp_socket.h \
-		 udp_server_socket.h \
-		 udp_socket.h \
-		 handshake.h \
-		 network_game_manager.h \
-		 converter.h \
-		 netdefs.h \
-		 message_manager.h \
-		 network_log.h \
-		 zip.h \
-		 player_stats.h \
-		 udp_broadcast.h \
-		 \
-		 synchronizeable_var/synchronizeable_var.h \
-		 synchronizeable_var/synchronizeable_vector.h \
-		 synchronizeable_var/synchronizeable_int.h \
-		 synchronizeable_var/synchronizeable_quaternion.h \
-		 synchronizeable_var/synchronizeable_string.h \
-		 synchronizeable_var/synchronizeable_float.h \
-		 synchronizeable_var/synchronizeable_bool.h \
-		 synchronizeable_var/synchronizeable_uint.h
-
-
+noinst_HEADERS = \
+		netdefs.h \
+		nettypes.h \
+		netincl.h \
+		\
+		synchronizeable.h \
+                network_manager.h \
+                shared_network_data.h \
+                network_socket.h \
+		network_stream.h \
+                data_stream.h \
+                network_protocol.h \
+		server_socket.h \
+		tcp_server_socket.h \
+		tcp_socket.h \
+		udp_server_socket.h \
+		udp_socket.h \
+		handshake.h \
+		network_game_manager.h \
+		converter.h \
+		peer_info.h \
+		netdefs.h \
+		message_manager.h \
+		network_log.h \
+		zip.h \
+		player_stats.h \
+		udp_broadcast.h \
+		\
+		proxy/network_settings.cc \
+		\
+                monitor/connection_monitor.h \
+                monitor/network_monitor.h \
+                monitor/network_node.h \
+		\
+		synchronizeable_var/synchronizeable_var.h \
+		synchronizeable_var/synchronizeable_vector.h \
+		synchronizeable_var/synchronizeable_int.h \
+		synchronizeable_var/synchronizeable_quaternion.h \
+		synchronizeable_var/synchronizeable_string.h \
+		synchronizeable_var/synchronizeable_float.h \
+		synchronizeable_var/synchronizeable_bool.h \
+		synchronizeable_var/synchronizeable_uint.h \
+		synchronizeable_var/synchronizeable_ip.h \
+		\
+		ip.h
Index: trunk/src/lib/network/README.NETWORK
===================================================================
--- trunk/src/lib/network/README.NETWORK	(revision 9406)
+++ trunk/src/lib/network/README.NETWORK	(revision 9406)
@@ -0,0 +1,20 @@
+
+
+This readme just gives some hints for the general network programming:
+
+ARCHITECTURE:
+The NetworkStream is in the center of this structure.
+
+
+UserId:
+containing the id of a user (==client). This id must be unique within a orxonox network its used especialy in the NetworkStream for node identification and also in the Synchronizeable base class for permissions checking (PERMISSION_OWNER)
+WARNING:
+There is some correlation between userids and the maxplayer, do not touch this.
+
+
+uniqueId:
+uniqueId is an id (unique :D) for each synchronizeable to be identified in a network. the number space for uniqueIds goes from 0 to maxplayers - 1
+
+
+NetworkStream PeerInfo list: (peers)
+The network node with the offset 0 is always the server to which the client must connect to (in case there are connections to other hosts at the same time).
Index: trunk/src/lib/network/converter.cc
===================================================================
--- trunk/src/lib/network/converter.cc	(revision 9391)
+++ trunk/src/lib/network/converter.cc	(revision 9406)
@@ -10,6 +10,6 @@
 
 ### File Specific:
-   main-programmer: Benjamin Wuest
-   co-programmer: ...
+   main-programmer: Benjamin Wuest (bwuest@ee.ethz.ch)
+   co-programmer: Christoph Renner (rennerc@ee.ethz.ch)
 */
 
@@ -30,5 +30,5 @@
 
 /* using namespace std is default, this needs to be here */
-using namespace std;
+
 
 /*!
@@ -38,5 +38,4 @@
 {
   /* set the class id for the base object */
-  //this->setClassID(CL_ENTITY_MANAGER, "EntityManager");
 }
 
Index: trunk/src/lib/network/data_stream.cc
===================================================================
--- trunk/src/lib/network/data_stream.cc	(revision 9391)
+++ trunk/src/lib/network/data_stream.cc	(revision 9406)
@@ -19,5 +19,5 @@
 
 /* using namespace std is default, this needs to be here */
-using namespace std;
+
 
 
Index: trunk/src/lib/network/handshake.cc
===================================================================
--- trunk/src/lib/network/handshake.cc	(revision 9391)
+++ trunk/src/lib/network/handshake.cc	(revision 9406)
@@ -10,12 +10,9 @@
 
 ### File Specific:
-   main-programmer: christoph
-   co-programmer:
+   main-programmer: Christoph Renner (rennerc@ee.ethz.ch)
+   co-programmer: Patirck Boenzli (boenzlip@orxonox.ethz.ch)
 */
 
 
-/* this is for debug output. It just says, that all calls to PRINT() belong to the DEBUG_MODULE_NETWORK module
-   For more information refere to https://www.orxonox.net/cgi-bin/trac.cgi/wiki/DebugOutput
-*/
 #define DEBUG_MODULE_NETWORK
 
@@ -25,5 +22,9 @@
 #include "debug.h"
 
-Handshake::Handshake( bool server, int clientId, int networkGameManagerId, int messageManagerId )
+
+
+
+
+ Handshake::Handshake( int nodeType, int clientId, int networkGameManagerId, int messageManagerId )
   : Synchronizeable()
 {
@@ -31,6 +32,6 @@
   this->setClassID(CL_HANDSHAKE, "Handshake");
 
-  this->setIsServer(server);
 
+  // register all variable handlers
   orxId_handler = registerVarId( new SynchronizeableInt( &localState.orxId, &remoteState.orxId, "orxonoxId", PERMISSION_ALL ) );
   version_handler = registerVarId( new SynchronizeableInt( &localState.version, &remoteState.version, "version", PERMISSION_ALL ) );
@@ -42,8 +43,16 @@
   errorString_handler = registerVarId( new SynchronizeableString( &localState.errorString, &remoteState.errorString, "errorString", PERMISSION_ALL ) );
 
+  this->nodeTypeHandler = registerVarId( new SynchronizeableInt( &localState.nodeType, &remoteState.nodeType, "nodeType", PERMISSION_ALL ) );
+
   candel_id = registerVarId( new SynchronizeableInt( &localState.canDel, &remoteState.canDel, "canDel", PERMISSION_ALL ) );
-  
+
   registerVar( new SynchronizeableString( &localState.preferedNickName, &remoteState.preferedNickName, "preferedNickName", PERMISSION_ALL ) );
+  // now synchronize only two of the available proxy server addresses
+  registerVar( new SynchronizeableIP( &this->proxy1, &this->proxy1, "proxy server 1", PERMISSION_MASTER_SERVER ) );
+  registerVar( new SynchronizeableIP( &this->proxy2, &this->proxy2, "proxy server 2", PERMISSION_MASTER_SERVER ) );
+  registerVar( new SynchronizeableInt( &this->redirectProxy, &this->redirectProxy, "proxy server redirection flag", PERMISSION_MASTER_SERVER ) );
 
+
+  // init the local state
   localState.completed = 0;
   localState.error = 0;
@@ -54,6 +63,9 @@
   localState.orxId = _ORXONOX_ID;
   localState.version = _ORXONOX_VERSION;
+  localState.nodeType = nodeType;
   localState.canDel = 0;
 
+
+  // init the remote state
   remoteState.completed = 0;
   remoteState.error = 0;
@@ -64,9 +76,18 @@
   remoteState.orxId = 0;
   remoteState.version = 0;
+  remoteState.nodeType = NET_CLIENT;
   remoteState.canDel = 0;
 
+
+  this->proxy1 = IP(0, 0);
+  this->proxy2 = IP(0, 0);
+  this->redirectProxy = 0;
+
+
+  // activate the synchronization process
   this->setSynchronized(true);
   PRINTF(0)("Handshake created clientId = %d\n", clientId);
 }
+
 
 /**
@@ -78,5 +99,6 @@
   for ( std::list<int>::iterator it = id.begin(); it != id.end(); it++ )
   {
-    if ( *it == orxId_handler )
+    // orxonox id handler
+    if ( *it == this->orxId_handler )
     {
       if ( remoteState.orxId != _ORXONOX_ID )
@@ -87,8 +109,8 @@
         continue;
       }
-
     }
 
-    if ( *it == version_handler )
+    // orxonox version handler
+    if ( *it == this->version_handler )
     {
       if ( remoteState.version != _ORXONOX_VERSION )
@@ -99,19 +121,36 @@
         continue;
       }
-
     }
 
+    // node type handler: for each node type there is a specific action to be taken
+    if ( *it == this->nodeTypeHandler)
+    {
+      if ( remoteState.nodeType == NET_MASTER_SERVER )
+      {
+        continue;
+      }
+      else if( remoteState.nodeType == NET_PROXY_SERVER_ACTIVE)
+      {
+        continue;
+      }
+      else if( remoteState.nodeType == NET_CLIENT)
+      {
+        continue;
+      }
+    }
+
+    // cancel
     if ( *it == candel_id )
     {
       PRINTF(0)("handshake finished candel changed\n");
     }
-
   }
 
-  if (
-      remoteState.orxId == _ORXONOX_ID &&
-      remoteState.version == _ORXONOX_VERSION
-     )
+  // handshake completed
+  if ( remoteState.orxId == _ORXONOX_ID &&
+       remoteState.version == _ORXONOX_VERSION )
+  {
     localState.completed = 1;
+  }
 }
 
Index: trunk/src/lib/network/handshake.h
===================================================================
--- trunk/src/lib/network/handshake.h	(revision 9391)
+++ trunk/src/lib/network/handshake.h	(revision 9406)
@@ -1,5 +1,9 @@
 /*!
  * @file network_stream.h
- *  implementation of a network pipe
+ *  implementation of a network pipe. This node handles the handshake of two network nodes and exchanges informationas
+ * vial to the connection setup.
+ *
+ * the local node only writes in the localState variable. the remoteState variable will be written from the remote network node
+ * so don't write into it!
  */
 
@@ -8,62 +12,110 @@
 
 #include "base_object.h"
+#include "ip.h"
 #include "synchronizeable.h"
+#include "shared_network_data.h"
 
-#define _ORXONOX_ID 0xF91337A0
+//!< a struct to save the handshakes to
+struct HandshakeState
+{
+  int           orxId;                         //!< orxonox id
+  int           version;                       //!< network protocol version
 
-#define _ORXONOX_VERSION 1
+  int           networkManagerId;              //!< unique id of the network manager
+  int           messageManagerId;              //!< unique id of the message manager
+  int           hostId;                        //!< host id
+  int           nodeType;                      //!< type of the network node
 
-struct HandshakeState {
-  int orxId;
-  int version;
-  
-  int networkManagerId;
-  int messageManagerId;
-  int hostId;
-  
-  int completed;
-  int canDel;
-  
-  int error;
-  
-  std::string errorString;
-  
+  int           completed;                     //!< true if completed
+  int           canDel;                        //!< true if marked for deletion
+
+  int           error;                         //!< error number
+
+  std::string   errorString;                   //!< error string
+
   //additional data
-  std::string preferedNickName;
+  std::string   preferedNickName;              //!< prefered nick name
 };
 
+
+//!< the handshake itself with some interface functions
 class Handshake : public Synchronizeable
 {
+
   public:
-    Handshake( bool server, int clientId = 0, int networkGameManagerId = 0, int messageManagerId = 0 );
-    inline bool       completed(){ return localState.completed != 0 && remoteState.completed != 0; }
-    inline bool       ok(){ return localState.error == 0 && remoteState.error == 0; }
-    inline int        getHostId(){ return remoteState.hostId; }
-    inline int        getNetworkGameManagerId(){ return remoteState.networkManagerId; }
-    inline int        getMessageManagerId(){ return remoteState.messageManagerId; }
-    inline void       doReject( std::string reason ){ localState.error = 1; localState.errorString = "the server rejected your connection ["+ reason +"]"; }
-    inline bool       canDel(){ return localState.canDel == 1 && remoteState.canDel == 1; }
-    inline bool       allowDel(){ return localState.canDel == 1; }
-    inline void       del(){ localState.canDel = 1; }
-    
-    inline void       setPreferedNickName( const std::string & nick ){ localState.preferedNickName = nick; }
+    Handshake( int nodeType, int clientId = 0, int networkGameManagerId = 0, int messageManagerId = 0 );
+
+
+    /* functions indicating states of the handshake */
+    /** @returns true if the handshake is completed */
+    inline bool completed(){ return localState.completed != 0 && remoteState.completed != 0; }
+    /** @returns true if no error has occured until now */
+    inline bool ok(){ return localState.error == 0 && remoteState.error == 0; }
+    /** stops the handshake and reject the other side with @param reason: string describing the reason */
+    inline void doReject( std::string reason ){ localState.error = 1; localState.errorString = "the server rejected your connection ["+ reason +"]"; }
+    /** @returns true if the handshake is finished and the instances can be deleted */
+    inline bool canDel(){ return localState.canDel == 1 && remoteState.canDel == 1; }
+    /** @returns true if the local state can be removed*/
+    inline bool allowDel(){ return localState.canDel == 1; }
+    /** marks the handshake to be deleted */
+    inline void del(){ localState.canDel = 1; }
+
+
+    /* the actual informations exchanged in the handshake */
+    /** @returns the host id of the remote host */
+    inline int  getHostId(){ return remoteState.hostId; }
+    /** @returns the unique id of the network game manager*/
+    inline int  getNetworkGameManagerId(){ return remoteState.networkManagerId; }
+    /** @returns the unique id of the message manager */
+    inline int  getMessageManagerId(){ return remoteState.messageManagerId; }
+    /** @returns the node type of the remote host */
+    inline int getRemoteNodeType() { return this->remoteState.nodeType; }
+
+    /** sets @param nick the prefereded nick name */
+    inline void setPreferedNickName( const std::string & nick ){ localState.preferedNickName = nick; }
+    /** @returns the prefered nick name */
     inline std::string getPreferedNickName(){ return remoteState.preferedNickName; }
-    
+
+    /** @returns if true the local client should reconnect to a proxy server from the proxy server list */
+    inline bool redirect() { return this->redirectProxy;}
+    /** @param flag: indicating if the client should be redirected */
+    inline void setRedirect(bool flag) { if( SharedNetworkData::getInstance()->isClient()) return; this->redirectProxy = (int)flag; }
+
+    /** @param address: the address of the proxy server 1 if any */
+    inline void setProxy1Address(IP address) { if( SharedNetworkData::getInstance()->isClient()) return; this->proxy1 = address; }
+    /** @returns the address of the proxy server 1 if any */
+    inline IP getProxy1Address() { return this->proxy1; }
+    /** @param address: the address of the proxy server 2 if any */
+    inline void setProxy2Address(IP address) { if( SharedNetworkData::getInstance()->isClient()) return; this->proxy2 = address; }
+    /** @returns the address of the proxy server 2 if any */
+    inline IP getProxy2Address() { return this->proxy2; }
+
+
+    /* variable handler function */
     virtual void varChangeHandler( std::list<int> & id );
 
+
   private:
-    HandshakeState localState;
-    HandshakeState remoteState;
-    
-    int netManId_handler;
-    int msgManId_handler;
-    int hostId_handler;
-    int completed_handler;
-    int error_handler;
-    int errorString_handler;
-    int orxId_handler;
-    int version_handler;
-    int candel_id;
+    HandshakeState     localState;                            //!< the local handshake state
+    HandshakeState     remoteState;                           //!< the remote handshake state
 
+    int                orxId_handler;                         //!< orxonox id handler
+    int                version_handler;                       //!< orxonox version id handler
+    int                netManId_handler;                      //!< network manager handler
+    int                msgManId_handler;                      //!< message manager handler
+    int                hostId_handler;                        //!< host id handler
+    int                nodeTypeHandler;                       //!< node type handler
+    int                proxy1Handler;                         //!< handler for the proxy
+    int                proxy2Handler;                         //!< handler for the proxy
+
+    int                completed_handler;                     //!< handshake completion handler
+    int                error_handler;                         //!< handshake error handler
+    int                errorString_handler;                   //!< handshake error string handler
+    int                candel_id;                             //!< handshake deletion handler
+    int                nodeType;                              //!, the type of the network node
+
+    int                redirectProxy;                         //!< true if the client should reconnect to a proxy server
+    IP                 proxy1;                               //!< ip address of the first proxy (0.0.0.0 of not available)
+    IP                 proxy2;                               //!< ip address of the second proxy (0.0.0.0 of not available)
 };
 
Index: trunk/src/lib/network/ip.cc
===================================================================
--- trunk/src/lib/network/ip.cc	(revision 9406)
+++ trunk/src/lib/network/ip.cc	(revision 9406)
@@ -0,0 +1,296 @@
+/**
+ * @file ip.cc
+ * @brief A IP class, that handles IP names and resolution.
+ *
+ * code taken from audiere.
+ *
+ *
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+### File Specific:
+   main-programmer: Benjamin Grauer
+ * co-programmer: Patrick Boenzli
+ */
+
+#include "ip.h"
+
+#include <iostream>
+
+#include "multi_type.h"
+#include "substring.h"
+
+/**
+ * @brief default constructor
+ */
+IP::IP()
+{
+  this->_host = 0;
+  this->_port = IP::_defaultPort;
+}
+
+
+/**
+ * @brief constructor from ip and port
+ * @param ip the IP
+ * @param port the Port
+ * @return self
+ */
+IP::IP(int ip, int port)
+{
+  this->_host = ip;
+  if (port != -1)
+    this->_port = port;
+  else
+    this->_port = IP::_defaultPort;
+}
+
+
+/**
+ * @brief constructor from a String
+ * @param ip the IP as a String.
+ * @param resolve if true, the IP is resolved via DNS,
+ * @return self
+ */
+IP::IP(const std::string& ip, bool resolve)
+{
+  *this = IP::stringToIP(ip, IP::_defaultPort, resolve);
+}
+
+/**
+ * @brief constructor from a String
+ * @param ip the IP as a String.
+ * @param port The port to be resolved.
+ * @param resolve if true, the IP is resolved via DNS,
+ * @return self
+ */
+IP::IP(const std::string& ip, int port, bool resolve)
+{
+  *this = IP::stringToIP(ip, port, resolve);
+}
+
+
+/**
+ * @brief constructor from an SDL net structure IPaddress
+ * @param ip the ip.
+ * @return self
+ */
+IP::IP(const IPaddress& ip)
+{
+  this->_host = ip.host;
+  this->_port = ip.port;
+}
+
+
+/**
+ * @brief copy constructor.
+ * @param ip the IP to copy.
+ * @return self
+ */
+IP::IP(const IP& ip)
+{
+  *this = ip;
+}
+
+
+/**
+ * @brief constructs an IP out of the four pairs and a Port.
+ * @param first The first octal.
+ * @param second The second octal.
+ * @param third The third octal.
+ * @param fourth The fourth octal.
+ * @param port The Port.
+ * @return self.
+ */
+IP::IP(unsigned int first, unsigned int second, unsigned int third, unsigned int fourth, int port)
+{
+  this->_host = (first << 24) +
+                (second << 16) +
+                (third <<  8) +
+                fourth;
+  this->_port = port;
+}
+
+
+/**
+ * @brief copy operator
+ * @param ip the IP to copy.
+ * @return self.
+ */
+const IP& IP::operator=(const IP& ip)
+{
+  this->_host = ip.host();
+  this->_port = ip.port();
+  return *this;
+}
+
+
+/**
+ * @brief copy operator
+ * @param ip the IP to copy.
+ * @return self.
+ */
+const IP& IP::operator=(const IPaddress& ip)
+{
+  this->_host = ip.host;
+  this->_port = ip.port;
+  return *this;
+}
+
+
+/**
+ * @brief comparison operator
+ * @param ip the IP to compare
+ * @return true if ip _and_ port match.
+ */
+bool IP::operator==(const IP& ip) const
+{
+  return (this->_host == ip.host() &&
+          this->_port == ip.port());
+}
+
+
+/**
+ * @brief comparison operator
+ * @param ip the IP to compare
+ * @return true if ip _or_ port do not match.
+ */
+bool IP::operator!=(const IP& ip) const
+{
+  return (this->_host != ip.host() ||
+          this->_port != ip.port());
+}
+
+
+/**
+ * @brief converts a String into an IP Object.
+ * @param ip The string holding an IP.
+ * @param port The port to be resolved.
+ * @param resolve if true, the IP is resolved via DNS,
+ * otherwise (resolve == false) the IP is being transformed
+ * from a String (xxx.xxx.xxx.xxx) to an integer.
+ *
+ * @return A newly constructed IP.
+ */
+IP IP::stringToIP(const std::string& ip, int port, bool resolve)
+{
+  if (resolve)
+  {
+    IPaddress ipaddr;
+
+    SDLNet_ResolveHost(&ipaddr, NULL, 2000);
+
+    return IP(ipaddr.host, port);
+  }
+  else
+  {
+    SubString ipaddr(ip, '.');
+    if(ip.size() != 4 )
+      return IP();
+
+    MultiType part0(ipaddr[0]);
+    MultiType part1(ipaddr[1]);
+    MultiType part2(ipaddr[2]);
+    MultiType part3(ipaddr[3]);
+
+    int addr = (part0.getInt() << 24) +
+               (part1.getInt() << 16) +
+               (part2.getInt() <<  8) +
+               part3.getInt();
+    return IP(addr, port);
+  }
+}
+
+
+/**
+ * @brief if you want to have a specific part of an IP
+ * @param part the n'th part of the IP addr (splitted by '.').
+ * @return the amount held in the designated part.
+ */
+int IP::ipPart(unsigned int part) const
+{
+  switch (part)
+  {
+    case 0:
+      return  (_host & 0xFF000000) >> 24;
+    case 1:
+      return  (_host & 0x00FF0000) >> 16;
+    case 2:
+      return  (_host & 0x0000FF00) >> 8;
+    case 3:
+      return  (_host & 0x000000FF);
+    default:
+      return -1;
+  }
+}
+
+
+/**
+ * @return the Ip as a string.
+ */
+std::string IP::ipString() const
+{
+  return IP::ipToString(this->_host, this->_port);
+}
+
+
+/**
+ * @brief converts an IPaddress struct into a String.
+ * @param ipaddr the IP address as a SDL_net struct.
+ * @return the string retrieved from the IP.
+ */
+std::string IP::ipToString(const IPaddress& ipaddr)
+{
+  int ip = SDLNet_Read32 (ipaddr.host);
+  return IP::ipToString(ip, ipaddr.port);
+}
+
+
+/**
+ * @brief converts a IP into a String (without port).
+ * @param ip the IP to put into the string.
+ * @param port -1 if not wanted
+ * @return the string of the ip.
+ */
+std::string IP::ipToString(int ip, int port)
+{
+  MultiType part0((int) (ip & 0xFF000000) >> 24);
+  MultiType part1((int) (ip & 0x00FF0000) >> 16);
+  MultiType part2((int) (ip & 0x0000FF00) >>  8);
+  MultiType part3((int) (ip & 0x000000FF) );
+
+  std::string addr = part3.getString() + "." + part2.getString() + "." +
+                     part1.getString() + "." + part0.getString();
+
+  if (port != -1)
+    addr += ":" + MultiType(port).getString();
+  return addr;
+}
+
+
+/// default port definition.
+int IP::_defaultPort = 9999;
+
+/**
+ * @brief if no IP is supplied this port is used, so that IP can be resolved usefully.
+ * @param defaultPort The default port.
+ */
+void IP::setDefaultPort(int defaultPort)
+{
+  IP::_defaultPort = defaultPort;
+}
+
+
+/**
+ * @brief print out the IP in a nice fashion
+ */
+void IP::debug() const
+{
+  std::cout << "IP is " << this->ipString() << std::endl;
+}
Index: trunk/src/lib/network/ip.h
===================================================================
--- trunk/src/lib/network/ip.h	(revision 9406)
+++ trunk/src/lib/network/ip.h	(revision 9406)
@@ -0,0 +1,68 @@
+
+/*!
+ * @file ip.h
+ *
+ * @brief the ip class is used to transform strings to ip's and backwards
+ * it can also be used to
+ */
+
+#ifndef __IP_H__
+#define __IP_H__
+
+#include "netincl.h"
+#include <string>
+
+
+
+//! A class to handle time itself
+class IP
+{
+  public:
+    /// CONSTRUCTORS
+    IP();
+    IP(int ip, int port);
+    IP(const std::string& ip, bool resolve = true);
+    IP(const std::string& ip, int port = -1, bool resolve = true);
+    IP(const IPaddress& ip);
+    IP(const IP& ip);
+    IP(unsigned int first, unsigned int second, unsigned int third, unsigned int fourth, int port = IP::_defaultPort);
+
+    /// OPERATORS
+    const IP& operator=(const IP& ip);
+    const IP& operator=(const IPaddress& ip);
+    bool operator==(const IP& ip) const;
+    bool operator!=(const IP& up) const;
+
+    /// RETRIVEAL
+    /** @returns the IP */
+    int host() const { return this->_host; };
+    int* hostRef()  { return &this->_host; }
+    /** @returns the Port */
+    int port() const { return this->_port; };
+    int* portRef() { return &this->_port; };
+
+    inline IPaddress getSDLNotation() { IPaddress sdlIP; sdlIP.host = this->_host; sdlIP.port = this->_port; return sdlIP; }
+
+    int ipPart(unsigned int part) const;
+    std::string ipString() const;
+
+    void debug() const;
+
+  public:
+    /// SETUP
+    static IP stringToIP(const std::string& ip, int port = -1, bool resolve = true);
+
+    static std::string ipToString(const IPaddress& ipaddr);
+    static std::string ipToString(int ip, int port = -1);
+
+    static void setDefaultPort(int defaultPort);
+    static int defaultPort(int defaultPort) { return IP::_defaultPort; };
+
+  private:
+    int           _host;           //!< The IP in int form.
+    int           _port;         //!< The Port number of the IP
+
+    static int    _defaultPort;  //!< Default Port
+};
+
+#endif /* __IP_H__ */
